package net.nevet5.buzzbot.database;

import net.nevet5.buzzbot.Config;

import java.sql.*;
import java.time.LocalDate;
import java.time.LocalTime;

public class SqlDB {
    //TODO Make this a two way class for reading and writing from db

    private long userId;
    private String userName;
    private int userDiscriminator;
    private Date date = Date.valueOf(LocalDate.now());
    private Time time = Time.valueOf(LocalTime.now());
    private boolean banType;
    private int banLength;
    private String banReason;
    private String modName;
    private long modId;
    private String serverName;
    private long serverId;

    private Connection connect;
    private Statement statement;
    private PreparedStatement preparedStatement;
    private ResultSet resultSet;

    public SqlDB() {
        try {
            Class.forName("com.mysql.jdbc.Driver");
            connect = DriverManager.getConnection("jdbc:mysql://" + Config.getConfig().getString("database.url") + "/" + Config.getConfig().getString("database.database") + "?user=" + Config.getConfig().getString("database.user") + "&password=" + Config.getConfig().getString("database.password"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void readDatabase() {
        try {
            Class.forName("com.mysql.jdbc.Driver");

            connect = DriverManager.getConnection("jdbc:mysql://" + Config.getConfig().getString("database.url") + "/" + Config.getConfig().getString("database.database") + "?user=" + Config.getConfig().getString("database.user") + "&password=" + Config.getConfig().getString("database.password"));

            statement = connect.createStatement();

            resultSet = statement
                    .executeQuery("SELECT * FROM masterbanlist");
        } catch (ClassNotFoundException | SQLException e) {
            throw new RuntimeException(e);
        }
    }

    public void insert() {
        try {
            statement = connect.createStatement();

            resultSet = statement.executeQuery("INSERT INTO " + Config.getConfig().getString("database.database") + " VALUES (default, " + userId + ", '" + userName + "', '" + userDiscriminator + "', '" + date + "', '" + time + "', " + banType + ", " + banLength + ", '" + banReason + "', '" + modName + "', " + modId + ", '" + serverName + "', " + serverId + ");");
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    private void query(ResultSet resultSet) throws SQLException {
        while (resultSet.next()) {
            userId = resultSet.getLong("userid");
            userName = resultSet.getString("username");
            userDiscriminator = resultSet.getInt("userdiscriminator");
            date = resultSet.getDate("bandate");
            time = resultSet.getTime("bantime");
            banType = resultSet.getBoolean("bantype");
            banLength = resultSet.getInt("");
            banReason = resultSet.getString("banreason");
            modName = resultSet.getString("modname");
            modId = resultSet.getLong("modid");
            serverName = resultSet.getString("servername");
            serverId = resultSet.getLong("serverid");
        }
    }

    private void close() {
        try {
            if (resultSet != null) {
                resultSet.close();
            }

            if (statement != null) {
                statement.close();
            }

            if (connect != null) {
                connect.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public void set(long userId, String userName, int userDiscriminator, Date date, Time time, boolean banType, int banLength, String banReason, String modName, long modId, String serverName, long serverId) {
        this.userId = userId;
        this.userName = userName;
        this.userDiscriminator = userDiscriminator;
        this.date = date;
        this.time = time;
        this.banType = banType;
        this.banLength = banLength;
        this.banReason = banReason;
        this.modName = modName;
        this.modId = modId;
        this.serverName = serverName;
        this.serverId = serverId;
    }

    public void setUserId(long userId) {
        this.userId = userId;
    }

    public long getUserId() {
        return userId;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserDiscriminator(int userDiscriminator) {
        this.userDiscriminator = userDiscriminator;
    }

    public int getUserDiscriminator() {
        return userDiscriminator;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public Date getDate() {
        return date;
    }

    public void setTime(Time time) {
        this.time = time;
    }

    public Time getTime() {
        return time;
    }

    public void setBanType(boolean banType) {
        this.banType = banType;
    }

    public boolean getBanType() {
        return banType;
    }

    public void setBanLength(int banLength) {
        this.banLength = banLength;
    }

    public int getBanLength() {
        return banLength;
    }

    public void setBanReason(String banReason) {
        this.banReason = banReason;
    }

    public String getBanReason() {
        return banReason;
    }

    public void setModName(String modName) {
        this.modName = modName;
    }

    public String getModName() {
        return modName;
    }

    public void setModId(long modId) {
        this.modId = modId;
    }

    public long getModId() {
        return modId;
    }

    public void setServerName(String serverName) {
        this.serverName = serverName;
    }

    public String getServerName() {
        return serverName;
    }

    public void setServerId(long serverId) {
        this.serverId = serverId;
    }

    public long getServerId() {
        return serverId;
    }
}
